package com.fp.persistence.pgeneral.menu;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.Query;

import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;

import javax.persistence.Version;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENEMENUSUBLEVELDESC*/
@Entity(name="TgeneMenuSubLevelDesc")
@Table(name="TGENEMENUSUBLEVELDESC")
public class TgeneMenuSubLevelDesc extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneMenuSubLevelDesc
*/
@EmbeddedId
private TgeneMenuSubLevelDescKey pk;
@Version
@Column(name="RECORDVERSION", nullable=true)

/**
* Optimistic locking del registro
*/
private Integer recordversion;

@Column(name="DESCRIPTION", nullable=true)

/**
* Descripcion del sub nivel
*/
private String description;

/**Contructor por defecto*/
public TgeneMenuSubLevelDesc(){
}
/**Contructor de TgeneMenuSubLevelDesc
@param pPk Clave Primaria del entity
*/
public TgeneMenuSubLevelDesc(TgeneMenuSubLevelDescKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneMenuSubLevelDesc
*/
public static TgeneMenuSubLevelDesc find(EntityManager pEntityManager,TgeneMenuSubLevelDescKey pKey) throws Exception{
    TgeneMenuSubLevelDesc obj = pEntityManager.find(TgeneMenuSubLevelDesc.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneMenuSubLevelDesc
@return El objeto que referencia a la Clave primaria de TgeneMenuSubLevelDesc
*/
public TgeneMenuSubLevelDescKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneMenuSubLevelDesc
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneMenuSubLevelDesc
*/
public void setPk(TgeneMenuSubLevelDescKey pPk){
  pk=pPk;
}
/**Obtiene el valor de recordversion
@return valor de recordversion*/
public Integer getRecordversion(){
  return recordversion;
}
/**Fija el valor de recordversion
@param pRecordversion nuevo Valor de recordversion*/
public void setRecordversion(Integer pRecordversion){
  recordversion=pRecordversion;
}

/**Obtiene el valor de description
@return valor de description*/
public String getDescription(){
  return description;
}
/**Fija el valor de description
@param pDescription nuevo Valor de description*/
public void setDescription(String pDescription){
  description=pDescription;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneMenuSubLevelDesc))return false;
    TgeneMenuSubLevelDesc that = (TgeneMenuSubLevelDesc) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneMenuSubLevelDesc
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneMenuSubLevelDesc
*/
public Object createInstance(){
 TgeneMenuSubLevelDesc instance=new TgeneMenuSubLevelDesc();	
 instance.setPk(new TgeneMenuSubLevelDescKey());
 return instance;
}
/**Clona la entidad TgeneMenuSubLevelDesc
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneMenuSubLevelDesc p=(TgeneMenuSubLevelDesc)this.clone();
  p.setPk((TgeneMenuSubLevelDescKey)this.pk.cloneMe());
  return p;
}

	//METODOS MANUALES
	/** Sentencia que devuelve un registro de TgeneMenuSubLevelDesc. */
	private static final String JPQL_MENU_SLEVEL_DESC = "from TgeneMenuSubLevelDesc tsld" + " where tsld.pk.menucode = :menucode"
        + " and tsld.pk.levelcode = :levelcode" + " and tsld.pk.sublevel = :sublevel" + " and tsld.pk.languagecode = :languagecode";
	/**
     * Metodo que emtrega la descripcion de un subnivel del menu.
     * 
     * @param pmenucode Codigo de menu.
     * @param pLevel Codigo de nivel de menu.
     * @param pSublevel Codigo de subnivel de menu.
     * @param planguagecode Codigo de lenguaje.
     * @return TgeneMenuSubLevelDesc
     * @throws Exception
     */
    public static TgeneMenuSubLevelDesc find(EntityManager pEntityManager, Integer pmenucode, Integer pLevel, Integer pSublevel, String planguagecode)
            throws Exception {
        Query qry = pEntityManager.createQuery(TgeneMenuSubLevelDesc.JPQL_MENU_SLEVEL_DESC);
        qry.setParameter("menucode", pmenucode);
        qry.setParameter("levelcode", pLevel);
        qry.setParameter("sublevel", pSublevel);
        qry.setParameter("languagecode", planguagecode);
        try {
        	return (TgeneMenuSubLevelDesc) qry.getSingleResult();
		} catch (NoResultException e) {
			return null;
		}
    }
	
}
